<?php
/*
Plugin Name: StatusPress
Plugin URI: http://pomomusings.com/2007/08/29/statuspress/
Description: StatusPress takes your Facebook status messages and imports them onto your WordPress blog. Open &quot;sidebar.php&quot; - or wherever you want your Facebook status updates to appear - in the &quot;Themes&quot; directory. Insert &quot;&lt;li&gt;&lt;?php echo statuspress(&#39;URL&#39;, &#39;TITLE&#39;, NUMOFITEMS); ?&gt;&lt;/li&gt;&quot; right after &quot;&lt;?php get_links_list(); ?&gt;&quot; - or again, wherever you want. Replace &quot;URL&quot; with the URL of your Facebook RSS feed, starting with &quot;http://&quot;. Replace &quot;TITLE&quot; to change the feed title.  Replace &quot;NUMOFITEMS&quot; to limit the number of items.  Only &quot;URL&quot; is required.
Author: Adam Walker Cleaveland - with special thanks to Chris Hatcher - Chris@UnderJC.com.  "Last Updated" time added by C. Scott Andreas (http://phoreo.com)
Author URI: http://www.pomomusings.com
Version: 1.0
*/

function statuspress() {


	// --- Initialize ---
	require_once (ABSPATH . WPINC . '/rss-functions.php');

	// --- Arguments ---
	$argnum = func_num_args();
	$arglist = func_get_args();
	if ($argnum >= 1) $url = $arglist[0];
	if ($argnum >= 2) $title = $arglist[1];
		else $title = '';
	if ($argnum >= 3) $numofitem = $arglist[2];
		else $numofitem = 0;	// 0 = infinite

	$disp = "\n<!-- statuspress -->\n";

	// --- Wrong Number of Arguments ---
	if ($argnum < 1 or $argnum > 3) {
		$disp .= "\t<p>statuspress Error: Wrong number of arguments! Read the friendly manual.</p>\n";

	// --- Get RSS ---
	} elseif ($rss = fetch_rss($url)) {
		


		// --- Item Title and Copyright ---

		
		if ($numofitem > 0) $rss->items = array_slice($rss->items, 0, $numofitem);
		foreach($rss->items as $item) {
			$title = $item[title];

			// Get the date + time of the last update from the RSS feed.
			$pubdate = $item[pubdate];
			// Convert this string to a time.
			$pubdate = strtotime($pubdate);
			
			// Calculate how long it's been since the status was updated.
			$today = time();
			$difference = $today - $pubdate;

			$link = htmlentities($item[link]);
			if ($title != '') {
				$disp .= "\t\t$title";

				// Display how long it's been since the last update.
				$disp .= "  (Updated ";
				
				// Show days if it's been more than a day.
				if(floor($difference / 84600) > 0) {
					$disp .= floor($difference / 84600);
					if(floor($difference / 84600) == 1) { $disp .= ' day, '; } else { $disp .= ' days, '; }
					$difference -= 84600 * floor($difference / 84600);
				}

				// Show hours if it's been more than an hour.
				if(floor($difference / 3600) > 0) {				
					$disp .= floor($difference / 3600);
					if(floor($difference / 3600) == 1) { $disp .= ' hour, '; } else { $disp .= ' hours, '; }
					$difference -= 3600 * floor($difference / 3600);
				}
				
				// Show minutes if it's been more than a minute.
				$disp .= floor($difference / 60);
				$difference -= 60 * floor($difference / 60);
				if(floor($difference / 60) == 1) { $disp .= ' minute, '; } else { $disp .= ' minutes ago)'; }
				$disp .= "\n";
			}

		}
		$disp .= "\t\n";

	// --- Not Found ---
	} else {
		$disp .= "\t<p>statuspress Error: Something bad happened! Try again later.</p>\n";
	}

	// --- Display ---
	return $disp ;
}

?>